{$IFNDEF FPC}
{Compiler Schalter von Turbo Pascal 7.0 }
{$A+,B-,D-,E-,F-,G+,I+,L-,N+,O-,P-,Q-,R-,S+,T-,V+,X+}
{$M 16384,0,655360}
{$Endif}

program DCF77;
{$IFDEF FPC}
  { die Version fuer DOS GO32V2 }
  {$Optimization ON}
  {$Optimization RegVar}
  {$Optimization PEEPHOLE}
  {$Optimization CSE}
  {$Optimization ASMCSE}
{$Endif}

{$DEFINE Echtzeitausgabe}
  {das Notebook hat nur USB Ports und zum Teil ist es nicht zulaessig}
{$DEFINE HatPortZugriff}

uses
{$IFDEF FPC}
  {$IFDEF Echtzeitausgabe}
    {$IFDEF  HatPortZugriff}
     ports,
    {$ENDIF}
  {$ENDIF}
  sysutils,crt;
{$else}
  crt,dos;
type
  TDateTime = double;
{$Endif}

const
  fCPU = 3.2e9;

  {Zeiten in ms, unter Freedos nur die Haelfte, bei Linux passt 100/1000 }
  {Versuch einer Kalibrierung}
  t_Abgesenkt1: word = 100;{54;}
  t_Abgesenkt2: word = 200;{54;}
  t_ges : word = 1000;{500;}

  Wochentage :array[1..7] of string[3] =
                ('Mon','Die','Mit','Don','Fre','Sam','Son');
  NullChar = '.';
  EinsChar = 'X';
  KalTageimMonat : array[1..12] of byte =
                     (31,28,31,30,31,30,31,31,30,31,30,31);
  Paritaet : array[0..15]of byte =
               (0,1,1,0,
                1,0,0,1,
                1,0,0,1,
                0,1,1,0);

  AusgabeZeile = 3;

  Schablone1 = '                     Minute  Stunde '+
               'KalTg Wo Mona Jahr';

  Schablone2 = '                     1248124P124812P'+
               '1248121241248112481248P';

var
  MinE,MinZ,MinP,
  StdE,StdZ,StdP,
  KalE,KalZ,
  TdW,
  MonE,MonZ,MonP,
  JahrE,JahrZ,JahrP,
  DatP,
  {
  ,SchaltSek
    }
   UmschaltMEZ_MeSZ,
   MESZ,MEZ         :shortint;
  KalTag,Monat,Jahr : word;

  IstSchaltJahr,
  AusgabeLaeuft : boolean;

  AusgabeText: string[59];

procedure Warte;
begin
  writeln;
  Write('Weiter mit Tastendruck');
  repeat
  until keypressed;
  Write(#8#8#8#8#8#8#8#8#8#8#8#8#8#8#8#8#8#8#8#8#8#8,'                      ');  
  while keypressed do
    readkey;
end;

{$IFDEF Echtzeitausgabe}

{minimales fuer serielle Schnittstelle COM1}
{Normalerweise
*   Port[BA+4] := Port[BA+4] AND/OR XXX ;
* aber das sind ja zwei Port Zugriffe, die sehr langsam sind, deshalb
* die Benutzung von der Variable PortBA4
* }
const
  BA = $03F8;  { $03F8=COM1, $02F8=COM2}
var
  {$IFNDEF HatPortzugriff}
  Port : array[BA..BA+6] of byte;
  {$EndIf}
  PortBA4:byte;

procedure ToggleDTR_RTS;
begin
  PortBA4 := PortBA4 XOR $03;
  Port[BA+4] := PortBA4;
end;

procedure DTR(An : Boolean);
begin
  If An then
    PortBA4 := PortBA4 OR 1
  else
    PortBA4 := PortBA4 AND 254;
  Port[BA+4] := PortBA4;
end;

procedure RTS(An : Boolean);
begin
  If An then
    PortBA4 := PortBA4 OR 2
  else
    PortBA4 := PortBA4 AND 253;
  Port[BA+4] := PortBA4;
end;
{$ENDIF}

function TestSchaltJahr(Jahr:word):boolean;
begin
  if (jahr AND 3) <>0 then
    TestSchaltJahr:=false
  else
    if jahr mod 100<>0 then
      TestSchaltJahr:=true
    else
      TestSchaltJahr:=(jahr mod 400=0);
end;

function TagDerWoche(jahr,monat,tag:word):shortint;
const
 MonKorr : array[1..12] of word =
           (0,3,2,5,0,3,5,1,4,6,2,4);
 var
   c : word;
begin
  c    := Jahr DIV 100;
  Jahr := Jahr MOD 100;
  IF Monat <=2 then
    begin
    IF Jahr = 0 then
      begin
      dec(c);
      Jahr := 99;
      end
    else
      dec(Jahr)
    end;
  TagDerWoche := (tag + MonKorr[Monat]+ Jahr + Jahr DIV 4
                  + C DIV 4 + 5*C +6) MOD 7 +1;
end;
procedure BitAusgabe(Wert:byte;bits:shortint;Posi:byte);
const
  cdiff = ord(EinsChar)-ord(NullChar);
begin
  For Bits := bits-1 downto 0 do
    begin
    inc(Posi);{hier vorne, weil String 1 basiert ist }
    {(-(Wert AND 1) ist entweder 0b11111111 oder 0b00000000}
    AusgabeText[Posi]:= chr( ord(NullChar)+  (-(Wert AND 1) AND(cDiff)));
    Wert := Wert shr 1;
    end;
end;

procedure AusgabeAktPos(Aktpos:byte);
begin
  Textbackground(green);
  textcolor(red);
  GotoXY(AktPos,AusgabeZeile+3);
  IF Aktpos > 1 then
    write(#8,' I ',AktPos)
  else
    Begin
    ClrEol;
    write('I ',AktPos);
    end;
  textcolor(lightgray);
end;

procedure Ausgabe;
begin
  GotoXY(1,AusgabeZeile);
  Textbackground(green);
  textcolor(lightgreen);
  CLREOL;
  writeln(Schablone1);
  CLREOL;
  textcolor(lightgray);
  writeln(Schablone2);
  CLREOL;
  textcolor(yellow);
  writeln(Ausgabetext,'#');
  AusgabeLaeuft := true;

  textcolor(lightgray);
  GotoXY(1,AusgabeZeile+4);
  clrEOL;
  Write(' ',StdZ,StdE,':',MinZ,MinE,' ',Wochentage[TdW],' ');
  Write(KalZ,KalE,'.',MonZ,MonE,'.',jahr div 100 :2,JahrZ,JahrE);
end;

procedure Init(minu,std,tag,mon,Jah:word);
var
  i : word;
begin
  Jahr  := Jah;
  JahrE := Jahr Mod 10;
  JahrZ := (Jahr Mod 100) Div 10;
  JahrP := Paritaet[JahrE] XOR Paritaet[JahrZ];
  write(jahrp,' ');
  IstSchaltJahr:= TestSchaltJahr(Jahr);

  Monat := (mon-1) Mod 12+1;
  MonE := Monat Mod 10;
  MonZ := Monat Div 10;
  MonP := Paritaet[MonE] XOR Paritaet[MonZ] XOR JahrP;
  write(Monp,' ');
  i := KalTageimMonat[Monat];

  IF (Monat=2) AND IstSchaltJahr then
    inc(i);

  Kaltag := (tag-1) Mod i +1;

  KalE := KalTag Mod 10;
  KalZ := KalTag Div 10;

  TdW := TagDerWoche(Jahr,Monat,KalTag);

  DatP := Paritaet[TdW] XOR Paritaet[KalE] XOR Paritaet[KalZ] XOR MonP;
  writeln(Datp,' ');
  Std  := Std Mod 24;
  StdE := Std Mod 10;
  StdZ := Std Div 10;
  StdP := Paritaet[StdE] XOR Paritaet[StdZ];


  Minu  := Minu Mod 60;
  MinE := Minu Mod 10;
  MinZ := Minu Div 10;
  MinP := Paritaet[MinE] XOR Paritaet[MinZ];


  Mez := 1;
  MeSZ := 1-Mez;
  {setlength(Ausgabetext,59);}
  Ausgabetext[0]:= #59;
  For i := 1 to 59 do
    AusgabeText[i] :=NullChar;

  AusgabeText[21]  := EinsChar;


  BitAusgabe(MeSZ,1,17);
  BitAusgabe(Mez,1,18);

  BitAusgabe(MinE,4,21);
  BitAusgabe(MinZ,3,25);
  BitAusgabe(MinP,1,28);

  BitAusgabe(StdE,4,29);
  BitAusgabe(StdZ,2,33);
  BitAusgabe(StdP,1,35);

  BitAusgabe(KalE,4,36);
  BitAusgabe(KalZ,2,40);
  BitAusgabe(TdW,3,42);

  BitAusgabe(MonE,4,45);
  BitAusgabe(MonZ,1,49);

  BitAusgabe(JahrE,4,50);
  BitAusgabe(JahrZ,4,54);

  BitAusgabe(DatP,1,58);

  AusgabeLaeuft := false;

  {$IFDEF Echtzeitausgabe}
  {Steuerregister von serieller Schnittstelle auf RTS=1 setzen}
  PortBA4:= 0;
  RTS(True);
  {$ENDIF}
end;

procedure incJahr;
begin
  inc(JahrE);
  IF JahrE > 9 then
    begin
    JahrE:= 0;
    inc(JahrZ);
    IF JahrZ >9 then
      JahrZ:= 0;
    end;

  inc(Jahr);
  { Bei ueberlauf abbrechen}
  IF Jahr = 0 then
    Halt(7);
  IstSchaltJahr:= TestSchaltJahr(Jahr);

  JahrP := Paritaet[JahrE] XOR Paritaet[JahrZ];
  BitAusgabe(JahrE,4,50);
  BitAusgabe(JahrZ,4,54);
end;

procedure incMonat;
begin
  inc(MonE);
  IF MonE > 9 then
    begin
    MonE:= 0;
    inc(MonZ);
    end;
  inc(Monat);
  IF Monat> 12 then
    begin
    Monat := 1;
    MonE:= 1;
    MonZ:= 0;
    incJahr;
    end;
  BitAusgabe(MonE,4,45);
  BitAusgabe(MonZ,1,49);
  MonP := Paritaet[MonE] XOR Paritaet[MonZ] XOR JahrP;
end;

procedure IncTag;
begin
  inc(TdW);
  IF TdW>7 then
    TdW := 1;

  inc(KalE);
  IF KalE>9 then
    begin
    KalE := 0;
    inc(KalZ);
    end;

  inc(KalTag);

  IF KalTag>KalTageimMonat[Monat] then
    begin
    IF NOT( (Monat = 2) AND IstSchaltJahr ) then
      Begin
      KalTag := 1;
      KalE:= 1;
      KalZ:= 0;
      IncMonat;
      end
    else
      IF (KalTag>(KalTageimMonat[2]+1)) then
        Begin
        KalTag := 1;
        KalE:= 1;
        KalZ:= 0;
        IncMonat
        end;
    end;

  DatP := Paritaet[TdW] XOR Paritaet[KalE] XOR Paritaet[KalZ] XOR MonP;
  BitAusgabe(KalE,4,36);
  BitAusgabe(KalZ,2,40);
  BitAusgabe(TdW,3,42);

  BitAusgabe(DatP,1,58);
end;

procedure IncStd;
begin
  inc(StdE);

  If (StdE=4) AND (StdZ=2) then
    begin
     StdE := 0;
     StdZ := 0;
     IncTag;
     end
  else
    begin
    IF StdE>9 then
      begin
      StdE := 0;
      inc(StdZ);
      end;
    end;
  StdP := Paritaet[StdE] XOR Paritaet[StdZ];

  BitAusgabe(StdE,4,29);
  BitAusgabe(StdZ,2,33);
  BitAusgabe(StdP,1,35);
end;

procedure IncMin;
begin
  inc(MinE);
  IF MinE>9 then
    begin
    MinE := 0;
    inc(MinZ);
    IF MinZ>5 then
      begin
      MinZ:=0;
      IncStd;
      end;
    BitAusgabe(MinZ,3,25);
    end;
  BitAusgabe(MinE,4,21);
  MinP := Paritaet[MinE] XOR Paritaet[MinZ];
  BitAusgabe(MinP,1,28);
end;

{$IFDEF Echtzeitausgabe}
procedure DCFAusgabe;
const
  Col1 = green;
  Col2 = Blue;
var
  d,i : byte;

begin
  Ausgabe;
  For i := 1 to 59 do
    begin
    AusgabeAktPos(i);

    d :=t_Abgesenkt1;
    IF AusgabeText[i] = EinsChar then
      d := t_Abgesenkt2;
    gotoxy(1,1);
    Writeln('       ');
    TextBackground(Col1);
    Textcolor(Col2);
    Write('Abgesenkt');
    TextBackground(Black);
    gotoxy(1,2);

   {Absenkung}
    ToggleDTR_RTS;
    delay(d);
   {Wieder normal}
    ToggleDTR_RTS;

    Write('         ');
    TextBackground(Col2);
    Textcolor(Col1);
    gotoxy(1,1);
    Write('Erhoeht');

    delay(t_ges-d);
    If keypressed then
      break;
    end;
  If keypressed then
    EXIT;
  {59.te Sekunde}
  delay(t_ges);
end;
{$ENDIF}

{$IFNDEF FPC}
function time:double;
var
  h,m,s,hs: word;
begin
  gettime(h,m,s,hs);
  time := (longint((60*h+m)*60+s)*100+hs)/8640000.0;
end;
{$ENDIF}

procedure Calibrate;
{Versuch einer Kalibrierung}
CONST
  RUNDEN_i = 100;
  GesuchteZeit= 1000; {ms}
var
  T1,T0,Tu,
  dtu,dt      : TDateTime;
  Durchlaeufe: longint;

  i  : word;
  
  function neuZeit(altzeit:word):word;
  var
    Runden : longint;
  begin
    write(altzeit);
    runden := 0;
    t0 := time;
    repeat
      tu := time;
    until t0<>tu;
    
    delay(altzeit);
    t0 := time;    
    repeat
      t1 := time;
      inc(Runden)
    until t0<>t1;
    {richtige Restzeit}
    dt := dtu*(1.0-runden*(runden_I/Durchlaeufe));
    t0 := t0+dt;
    altzeit := round(altzeit*(altzeit/((t0-tu)*86400000.0)));
    writeln(' -> ',altZeit);
    Neuzeit := altZeit;
  end;
  
begin
  i := RUNDEN_i;
  Durchlaeufe := 0;
  {Timerwechsel abwarten}
  T0 := time;
  repeat
    tu := time;
  until t0<>tu;
  
  T1 := Tu;
  repeat
    T0 := T1;
    repeat
      t1 := time;
      inc(Durchlaeufe)
    until t0<>t1;
    dec(i);
  until i = 0;
  {dtu = ein Timerintervall}
  dtu := (t1-tu)/RUNDEN_i;
  writeln(dtu*86400000.0:0:4,' ms');
  writeln(Durchlaeufe:0);  
  t_ges := neuZeit(t_ges);

  t_Abgesenkt1 := neuZeit(t_Abgesenkt1);

  t_Abgesenkt2 := neuZeit(t_Abgesenkt2);
  warte;
end;

var
{$IFNDEF Echtzeitausgabe}
  ZielMonat,
  ZielTag  :Word;
{$ENDIF}
  ZielJahr :Word;
  min_ges  : longInt;
  t1,t0 : TDateTime;

const
  DeltaJahr = 2012-2000;
BEGIN
  Calibrate;
  clrscr;


  Init(50,23,28,2,2012-DeltaJahr);

{$IFNDEF Echtzeitausgabe}
  ZielMonat:= Monat;
  ZielTag  := KalTag;
{$ENDIF}
  ZielJahr := Jahr+DeltaJahr;

  ausgabe;
  warte;
  min_ges := 0;
  while keypressed do
    readkey;
  writeln(WochenTage[TdW],',den ',Kaltag:2,'.',Monat,'.',Jahr);

  t0:= time;

  {$IFDEF Echtzeitausgabe}
  repeat
    DCFAusgabe;
{Sofortiger Abbruch nach einer Minute}
    break;

    If keypressed then
      break;
    {incJahr;incMonat;TdW := TagDerWoche(Jahr,Monat,KalTag);}
    {incTag;incStd;}
    incMin;
 until (Jahr>ZielJahr);
 {$ELSE}
 {Geschwindigkeitstest}
 repeat
   incMin;
   inc(min_ges)
 until (ZielJahr=Jahr)AND(ZielMonat=Monat) AND (ZielTag=KalTag)
          AND (StdZ=1) AND (StdE=7) AND (MinZ=5) AND (MinE=7);
 {$ENDIF}
  t1:= (time-t0)*86400.0;
  Textcolor(lightgray);
  Ausgabe;
  writeln;
  Textbackground(black);
  Textcolor(green);
  writeln(WochenTage[TdW],',den ',Kaltag:2,'.',Monat,'.',Jahr);
  writeln(TagDerWoche(Jahr,Monat,KalTag));
  writeln(min_ges,' Minuten in ',t1:0:2,' Sekunden');
  IF min_ges>0 then
    writeln(t1/min_ges*fCPU:0:3);
  warte;
END.
